# SlideShowPluginJquery
Simple Slideshow with Jquery. Create by Nguyen Huu Duong


###Just download source and run file ```index.html``` to view demo :)



## Installation & Usage

###Step 1: Link required files

First and most important, the jQuery library needs to be included. 
Next, download the package from this site and link the the Javascript file "nhduongSlide.js".

```sh
<!-- jQuery library (served from Google) -->
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
<!-- nhduongSlideShow Javascript file -->
<script src="/js/nhduongSlide.js"></script>
```

Coppy some image and icon  from ```images``` folder into your project

###Step 2: Create HTML tag

Create a HTML element:
You can use id or class
```sh
<div id="wrapper">
</div>
```
###Step 3: Call the nhduongSlide

```sh
//list image
    var images = [
        {
            caption : "The Sony Xperia Z3 isn't a phone that you'd have thought would make a lot of sense",
            url : "images/1.png"
        },
        {
            caption : "The Nexus 6 is finally here. It's also bigger, more powerful and more expensive than the Nexus 5",
            url : "images/2.png"
        },
        {
            caption : "A smaller LG G3 makes sense, but the G3 S is cut-down in every respect without cutting the price quite enough to make it a good deal",
            url : "images/3.png"
        },
        {
            caption : "",
            url : "images/4.png"
        }
    ];

$('#wrapper').nhduongSlide({
   class_name : 'mySlide',
    speed : 5000,
    effect : 2000,
    width : 800,
    height : 300,
    controlBtn : {
        top : 250,
        left : 342
    },
    caption_position : {
        top : 10,
        left : 10
    },
    auto_play : true,
    images :images
});
```
#### Variable images

This is the list image of slide show
Each list item is a slide, this contain a image and caption

#### ```Options ``` of nhduongSlide

* ```class_name``` : class name of element contain silde show. Default is ```nhduongSlide```
* ```speed``` : speed of animation when slide auto play. Default is ```3000```
* ```effect``` : effect of image when it fadeIn: 'slow', 'fast' or number of time .... Default is ```slow```
* ```width``` : width of slide show. Default is ```600```
* ```height``` :  height of slide show. Default is ```250```
* ```controlBt``` : position of box contain  prev, next, play/pause button. Default is ```controlBt.top=218```,```controlBt.left=242```
* ```caption_position``` :  postion of caption of image. Default is ```nhduongSlide```
* ```auto_play``` :  if auto_play = true, slide show will be auto play. Default is ```controlBtn.top = 20```, ```controlBtn.left = 0```
* ```images``` : list image of silde show.

##License

Released under the MIT license - http://opensource.org/licenses/MIT
Let's get on with it!

##Author

Written by Nguyen Huu Duong - http://vn.linkedin.com/in/nhduong29

Gmail : nhduong29@gmail.com
