/**
 * Created by nhduong29 on 1/12/2015.
 */
;(function($){

    $.fn.nhduongSlide = function(options){

        //default setting
        var settings = $.extend({
            class_name : "nhduongSlide",
            speed : 3000,
            effect : 'slow',
            width : 600,
            height : 250,
            auto_play : true,
            controlBtn : {
                top : 218,
                left : 242
            },
            caption_position : {
                top : 20,
                left : 0
            },
            images :[
                {
                    caption : "",
                    url : "images/img1.jpg"
                },
                {
                    caption : "",
                    url : "images/img2.jpg"
                },
                {
                    caption : "",
                    url : "images/img3.jpg"
                }
            ]
        },options);

        //object contain all image of slide show
        var $list_img;
        //object contain all caption of slide show
        var $list_caption;
        //total image of slide show
        var $list_img_size;

        //position of current image on slide show
        var $current_img;

        //timer of animation off slide show
        var $interval;

        //state of slide= play || pause
        var $playing;

        /**
         * init element for slide show
         */
        $.fn.nhduongSlide.initialize = function (){
            for(var i = 0;i < settings.images.length;i++){
                $('.'+settings.class_name).append('<img class="_image" src="'+settings.images[i].url+'">');
                $('.'+settings.class_name).append('<div class="caption_image">'+settings.images[i].caption+'</div>');
            }
            $list_img = $('.'+settings.class_name).children('img');
            $list_caption = $('.'+settings.class_name).children('.caption_image');
            $list_img_size = settings.images.length;
            $current_img = 0;
            $playing = false;

            $list_img.attr("id", function (arr) {
                return "nhduong_slide_img_" + arr;
            });
            $list_caption.attr("id", function (arr) {
                return "nhduong_slide_caption_" + arr;
            });



            $('.'+settings.class_name).append('<div class="controlBtn"><div class="prevBtn"></div><div class="playNstop"></div><div class="nextBtn"></div></div>');
            if(settings.auto_play == true){
                $.fn.nhduongSlide.start();
            }else{
                $.fn.nhduongSlide.stop();
            }
        }

        /**
         * Set appearance for slide
         */
        $.fn.nhduongSlide.initialize_appearance = function (){
            //set style for slide container
            $('.'+settings.class_name).css({
                position: 'relative',
                width: settings.width+'px',
                height: settings.height+'px',
                margin: '0 auto'
            });

            //set style for image of slide show
            $('._image').css({
                position: 'absolute',
                top: 0,
                left: 0
            });

            //set style for a group control button
            $('.controlBtn').css({
                position: 'absolute',
                'z-index': 100,
                top: settings.controlBtn.top+'px',
                left: settings.controlBtn.left+'px',
                width: '116px',
                height: '32px'
            });

            /**
             * set style for caption of image
             */
            $('.caption_image').css({
                position: 'absolute',
                top : settings.caption_position.top+'px',
                left : settings.caption_position.left+'px',
                background: 'rgba(204,51,51,1)',
                color:'#FFFFFF',
                'font-size':'20px',
                'font-family': "Arial",
                'text-transform':'uppercase',
                float:'left',
                display:'block',
                clear:'both',
                'margin-top':'10px'
            });

            //set style for prev button
            $('.prevBtn').css({
                left: 0,
                background: 'url("images/icon/prev.png")'
            });

            //set style for next button
            $('.nextBtn').css({
                left: '80px',
                background: 'url("images/icon/next.png")'
            });

            $('.prevBtn,.nextBtn ,.playNstop').css({
                float: 'left',
                'z-index': 100,
                width: '32px',
                height: '32px',
                'margin-left': '5px'
            });

            //Hide all image have position # 0
            $('.'+settings.class_name+' img:gt(0)').hide();
            $('.'+settings.class_name+' .caption_image:gt(0)').hide();

        }

        /**
         * event when click start button
         */
        $.fn.nhduongSlide.start = function(){
            $(".playNstop").css({ "background-image" : "url(images/icon/pause.png)" });
            $interval = setInterval(function(){
                $.fn.nhduongSlide.nextIMG();
            },settings.speed);
            $playing = true;
        }

        /**
         * Event when click stop button
         */
        $.fn.nhduongSlide.stop = function () {
            $(".playNstop").css({ "background-image" : "url(images/icon/play.png)" });
            clearInterval($interval);
            $playing = false;
        }

        /**
         * Click prev button
         */
        $.fn.nhduongSlide.prevIMG = function(){
            var $prev_imgPosition = $current_img - 1;
            $('#nhduong_slide_img_' + $current_img).fadeOut();
            $('#nhduong_slide_caption_' + $current_img).fadeOut();
            if($prev_imgPosition >= 0){
                $('#nhduong_slide_img_' + $prev_imgPosition).fadeIn(settings.effect);
                $('#nhduong_slide_caption_' + $prev_imgPosition).fadeIn(settings.effect);
            }else{
                $('#nhduong_slide_img_' + ($list_img_size - 1)).fadeIn(settings.effect);
                $('#nhduong_slide_caption_' + ($list_img_size - 1)).fadeIn(settings.effect);
            }
            if($current_img > 0){
                $current_img = $current_img -1;
            }else{
                $current_img = $list_img_size - 1;
            }
        }

        /**
         * Click next button
         */
        $.fn.nhduongSlide.nextIMG = function(){
            var $next_imgPosition = $current_img + 1;
            $('#nhduong_slide_img_' + $current_img).fadeOut();
            $('#nhduong_slide_caption_' + $current_img).fadeOut();
            if($next_imgPosition < $list_img_size){
                $('#nhduong_slide_img_' + $next_imgPosition).fadeIn(settings.effect);
                $('#nhduong_slide_caption_' + $next_imgPosition).fadeIn(settings.effect);
            }else{
                $('#nhduong_slide_img_0').fadeIn(settings.effect);
                $('#nhduong_slide_caption_0').fadeIn();
            }

            if($current_img < $list_img_size -1){
                $current_img = $current_img + 1;
            }else{
                $current_img = 0;
            }
        }

        return this.each(function(){
            $(this).append('<div class="'+settings.class_name+'"></div>');
            $.fn.nhduongSlide.initialize();
            $.fn.nhduongSlide.initialize_appearance();


            $('.prevBtn').click(function(){
                $.fn.nhduongSlide.stop();
                $.fn.nhduongSlide.prevIMG();

            });

            $('.nextBtn').click(function(){
                $.fn.nhduongSlide.stop();
                $.fn.nhduongSlide.nextIMG();
            });

            $('.playNstop').click(function(){
                if($playing){
                    $.fn.nhduongSlide.stop();
                }else{
                    $.fn.nhduongSlide.start();
                }
            });
        });
    }
}(jQuery));
